// ****************************************************
// *  MMmega01/02 :example of using in-build periferials
// *  RTC: PCF8583, DS1305
// *  DataFlash AT45DB011
// *  ver beta 1.0
// ****************************************************

#pragma language=extended
#include <iom103.h>
#include <ina90.h>
#include <i2c.h>
#include <SPI.h>
#include <AT45DB011.h>
#include <DS1305.h>

// delay routine
void delay(void)
{
  unsigned int a = 0xffff;
    while(a--);
}

void setup(void)
{
MCUCR =0xc0;         // Eneble external SRAM with wait state
SPI_init();          // Initialize SPI
AT45DB011_init();    // Initialize DataFlash
DS1305_init();       // Initialize RTC SPI
i2c_init();          // Initialize RTC I2C
}  

void main(void)
{
unsigned char data1,data2,hours,minutes,seconds;
setup();
delay();

for (;;)
{
// Eneble oscillator note: after power up oscillator is atopped
DS1305_write_byte(0x8f,0);               // disable write protection
DS1305_write_byte(0x8f,0);               // Enable oscilator

// Read time from RTC DS1305
hours=DS1305_read_byte(0x02);            // read hours
minutes=DS1305_read_byte(0x01);          // read minutes
seconds=DS1305_read_byte(0x00);          // read seconds

// Read time from RTC PCF8583
hours=PCF8583_read_byte(0x04);           // read hours
minutes=PCF8583_read_byte(0x03);         // read minutes
seconds=PCF8583_read_byte(0x02);         // read seconds

// Write two bytes to Dataflash buffer
DATAFLASH_write_mem_buf(0,0x01);
DATAFLASH_write_mem_buf(1,0x02);

// Write buffer to page
DATAFLASH_write_mem_buffer_to_page(0x0);
while (!(DATAFLASH_read_mem_stat() & 0x80));     // wait for DataFlash ready flag

// Read page to buffer
DATAFLASH_read_mem_page_to_buffer(0x00);
while (!(DATAFLASH_read_mem_stat() & 0x80));     // wait for DataFlash ready flag

// Read two bytes from buffer
data1=DATAFLASH_read_mem_buf(0);
data2=DATAFLASH_read_mem_buf(1);

// Read two bytes directly from Dataflash with-out buffer 
data1=DATAFLASH_read_mem_main(0,0);
data2=DATAFLASH_read_mem_main(0,1);
}
}
